VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Form1"
   ClientHeight    =   8295
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7575
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   553
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   505
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picCanvas 
      AutoRedraw      =   -1  'True
      Height          =   7560
      Left            =   0
      ScaleHeight     =   500
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   500
      TabIndex        =   5
      Top             =   720
      Width           =   7560
   End
   Begin VB.Timer tmrMoveShot 
      Left            =   3840
      Top             =   120
   End
   Begin VB.CommandButton cmdFire 
      Caption         =   "Fire"
      Default         =   -1  'True
      Height          =   375
      Left            =   1920
      TabIndex        =   4
      Top             =   120
      Width           =   735
   End
   Begin VB.TextBox txtSpeed 
      Height          =   285
      Left            =   1200
      TabIndex        =   3
      Text            =   "50"
      Top             =   360
      Width           =   495
   End
   Begin VB.TextBox txtDegrees 
      Height          =   285
      Left            =   1200
      TabIndex        =   1
      Text            =   "45"
      Top             =   0
      Width           =   495
   End
   Begin VB.Label Label1 
      Caption         =   "Speed (m/s)"
      Height          =   255
      Index           =   1
      Left            =   0
      TabIndex        =   2
      Top             =   360
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Angle (degrees)"
      Height          =   255
      Index           =   0
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'http://hyperphysics.phy-astr.gsu.edu/hbase/traj.html#tra4
' Distance: 2 * V^2 * Sin(T) * Cos(T) / g = V^2 * Sin(2*T) / g

Private Const PI As Double = 3.14159265

Private Const XMAX As Single = 500
Private Const YMAX As Single = 500

Private Const HOUSE_HGT As Single = 10
Private Const HOUSE_WID As Single = 14
Private Const OVERHANG As Single = 4
Private Const CANNON_LEN As Single = 20
Private Const CANNON_HGT As Single = 7

Private m_HouseX As Single
Private m_HouseY As Single

Private m_Theta As Single
Private m_BulletX As Single
Private m_BulletY As Single
Private m_Vx As Single
Private m_Vy As Single

Private Const TICKS_PER_SECOND As Single = 10

' Acceleration in meters per tick squared.
Private Const m_YAcceleration As Single = 9.8 / TICKS_PER_SECOND ^ 2

Private Declare Function Polygon Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI, ByVal nCount As Long) As Long
Private Type POINTAPI
    X As Long
    Y As Long
End Type

Private Sub DrawField()
Dim pts() As POINTAPI
Dim cx As Single
Dim cy As Single

    picCanvas.Cls

    ' Draw the house.
    ReDim pts(1 To 7)
    pts(1).X = m_HouseX: pts(1).Y = m_HouseY
    pts(2).X = pts(1).X: pts(2).Y = pts(1).Y - HOUSE_HGT
    pts(3).X = pts(2).X - OVERHANG: pts(3).Y = pts(2).Y
    pts(4).X = pts(3).X + OVERHANG + HOUSE_WID / 2: pts(4).Y = pts(3).Y - OVERHANG - HOUSE_WID / 2
    pts(5).X = pts(4).X + OVERHANG + HOUSE_WID / 2: pts(5).Y = pts(3).Y
    pts(6).X = pts(5).X - OVERHANG: pts(6).Y = pts(2).Y
    pts(7).X = pts(6).X: pts(7).Y = pts(1).Y
    picCanvas.DrawMode = vbCopyPen
    picCanvas.ForeColor = vbBlue
    picCanvas.FillColor = vbWhite
    picCanvas.FillStyle = vbSolid
    picCanvas.DrawStyle = vbSolid
    Polygon picCanvas.hdc, pts(1), UBound(pts)

    ' Draw the cannon.
    On Error Resume Next
    m_Theta = CSng(txtDegrees.Text) * PI / 180
    If Err.Number <> 0 Then
        m_Theta = 0
        Err.Clear
    End If
    If m_Theta > PI / 2 Then m_Theta = PI / 2
    If m_Theta < 0 Then m_Theta = 0
    On Error GoTo 0

    cx = 10 + CANNON_HGT / 2
    cy = YMAX - 10 - CANNON_HGT / 2
    ReDim pts(1 To 4)
    pts(1).X = cx - CANNON_HGT * Cos(PI / 2 - m_Theta) / 2: pts(1).Y = cy - CANNON_HGT * Sin(PI / 2 - m_Theta) / 2
    pts(2).X = pts(1).X + CANNON_LEN * Cos(m_Theta): pts(2).Y = pts(1).Y - CANNON_LEN * Sin(m_Theta)
    pts(3).X = pts(2).X + CANNON_HGT * Cos(PI / 2 - m_Theta): pts(3).Y = pts(2).Y + CANNON_HGT * Sin(PI / 2 - m_Theta)
    pts(4).X = pts(3).X - CANNON_LEN * Cos(m_Theta): pts(4).Y = pts(3).Y + CANNON_LEN * Sin(m_Theta)
    picCanvas.DrawMode = vbCopyPen
    picCanvas.ForeColor = vbBlack
    picCanvas.FillColor = RGB(192, 192, 192)
    picCanvas.FillStyle = vbSolid
    picCanvas.DrawStyle = vbSolid
    Polygon picCanvas.hdc, pts(1), UBound(pts)

    picCanvas.FillColor = RGB(128, 128, 128)
    picCanvas.Circle (cx, cy + CANNON_HGT / 2), CANNON_HGT * 1.5, vbBlack, -0.001, -PI

    m_BulletX = pts(2).X + CANNON_HGT * Cos(PI / 2 - m_Theta) / 2 + _
        CANNON_HGT * Cos(m_Theta) * 0.6
    m_BulletY = pts(2).Y - CANNON_HGT * Sin(PI / 2 - m_Theta) / 2 - _
        CANNON_HGT * Sin(m_Theta) * 0.6
End Sub
Private Sub MoveHouse()
    m_HouseX = XMAX * 2 / 3 + Rnd * XMAX / 3 - HOUSE_WID - OVERHANG
    m_HouseY = YMAX - (Rnd * YMAX / 4) - 3
End Sub

Private Sub cmdFire_Click()
Dim speed As Single

    ' Redraw.
    DrawField

    ' Get the speed.
    On Error Resume Next
    speed = CSng(txtSpeed.Text)
    If Err.Number <> 0 Then
        MsgBox "Invalid speed", vbExclamation, "Invalid Speed"
        Exit Sub
    End If
    On Error GoTo 0
    If speed < 1 Then
        MsgBox "Speed must be at least 1 mps", vbExclamation, "Invalid Speed"
        Exit Sub
    End If

    ' Get the speed components in meters per tick.
    m_Vx = speed * Cos(m_Theta) / TICKS_PER_SECOND
    m_Vy = -speed * Sin(m_Theta) / TICKS_PER_SECOND ' Negative to go up.

    ' Disable UI elements.
    cmdFire.Enabled = False
    txtDegrees.Enabled = False
    txtSpeed.Enabled = False
    Screen.MousePointer = vbHourglass
    DoEvents

#If DEBUGGING Then
    ' Draw the location where the cannon ball
    ' should pass the Y position where it started.
    ' Distance = 2 * V^2 * Sin(T) * Cos(T) / g = V^2 * Sin(2*T) / g
    picCanvas.FillColor = vbBlue
    picCanvas.Circle (m_BulletX + 2 * speed ^ 2 * Sin(m_Theta) * Cos(m_Theta) / 9.8, m_BulletY), CANNON_HGT / 2, vbBlue
#End If

    ' Start moving the cannon ball.
    tmrMoveShot.Enabled = True
End Sub
Private Sub Form_Load()
    tmrMoveShot.Enabled = False
    tmrMoveShot.Interval = 1 / TICKS_PER_SECOND * 1000
    Randomize
    MoveHouse

    DrawField
End Sub

Private Sub tmrMoveShot_Timer()
    ' Erase the cannon ball's previous position.
    picCanvas.FillColor = picCanvas.BackColor
    picCanvas.Circle (m_BulletX, m_BulletY), CANNON_HGT / 2, picCanvas.BackColor

    ' Move the cannon ball.
    m_Vy = m_Vy + m_YAcceleration
    m_BulletX = m_BulletX + m_Vx
    m_BulletY = m_BulletY + m_Vy

    ' Draw the new cannon ball.
    picCanvas.Circle (m_BulletX, m_BulletY), CANNON_HGT / 2, vbBlack

    ' See if we should stop.
    If (m_BulletY > picCanvas.ScaleHeight) Or (m_BulletX > picCanvas.ScaleWidth) Then _
        ' Stop running.
        tmrMoveShot.Enabled = False

        ' Re-enable UI elements.
        cmdFire.Enabled = True
        txtDegrees.Enabled = True
        txtSpeed.Enabled = True
        Screen.MousePointer = vbDefault
    End If
End Sub

Private Sub txtDegrees_Change()
    DrawField
End Sub

Private Sub txtSpeed_Change()
    DrawField
End Sub


